/*
 * xpainter.cc
 * 
 * X painter for direct XLib access. 
 * 
 * Copyright (c) 2002 by Wolfgang Wieser (wwieser@gmx.de) 
 * 
 * This file is part of QtXLib (Fast XLib drawing interface for Qt/X11). 
 * 
 * This file may be distributed and/or modified under the terms of the 
 * GNU General Public License version 2 as published by the Free Software 
 * Foundation. 
 * 
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

#include "xpainter.h"

namespace QTX
{

// Okay, need semi-legal way to access gc in QPainter: 
struct QPainterRipper : QPainter
{
	QPainterRipper() : QPainter() {}
	~QPainterRipper() {}
	
	GC get_gc(bool brush)
		{  return(brush ? gc_brush : gc);  }
};

void XPainter::QCopyGC(const QPainter &qp,bool brush,ulong valuemask)
{
	XCopyGC(dpy,((QPainterRipper*)(&qp))->get_gc(brush),valuemask,gc);
}


void XPainter::_setup(const QPaintDevice *pd)
{
	qpd=pd;
	dpy=pd->x11Display();
	drw=pd->handle();
	gc=XCreateGC(dpy,drw,0,NULL);
	
	// ** Available: 
	// int             x11Screen() const;
	// int             x11Depth() const;
	// int             x11Cells() const;
	// Qt::HANDLE      x11Colormap() const;
	// bool            x11DefaultColormap() const;
	// void           *x11Visual() const;
	// bool            x11DefaultVisual() const;
}


void XPainter::_cleanup()
{
	XFreeGC(dpy,gc);
	qpd=NULL;
}

}  // end of namespace QTX
